unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, Pictures, Defines, UnitLocation, UnitBUS, UnitMISS;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Open1: TMenuItem;
    Save1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Close1: TMenuItem;
    SaveDialog1: TSaveDialog;
    ScrollBox1: TScrollBox;
    map: TImage;
    procedure Open1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
  private
    OpenName                 : String;
    SaveName                 : String;
    OpenExt                  : String;
    SaveExt                  : String;
    LB, RT                   : TProjected;
    Rotate, Scale            : Double;

    procedure OpenPicture(Name:String);
    procedure SavePicture(Name:String);
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.DFM}


procedure TForm1.Open1Click(Sender: TObject);
begin
  OpenDialog1.Title := 'Open picture/map';
  OpenDialog1.Filter := 'Image files|*.BMP;*.GIF;*.PNG;*.PBM;*.PGM;*.PPM;|'+
                        'Map files|*.SIJ;*.MIS';
  if OpenDialog1.Execute then
  Begin
    OpenPicture(OpenDialog1.FileName);
  End;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Doublebuffered := True;
  Bus := TBus.Create;
end;


procedure TForm1.Close1Click(Sender: TObject);
begin
  Save1.Enabled := False;
  close;
end;


procedure TForm1.Save1Click(Sender: TObject);
begin
  SaveDialog1.Title := 'Save picture/map';
  SaveDialog1.Filter := 'Image files|*.BMP;*.GIF;*.PNG;*.PBM;*.PGM;*.PPM;|'+
                        'Map files|*.SIJ;*.MIS;|';
  if SaveDialog1.Execute then
  Begin
    SavePicture(SaveDialog1.FileName);
  End;
end;



procedure TForm1.OpenPicture(Name:String);
Var
  fake                       : PImage;
  Pict                       : TPictures;
  tmpI                       : Integer;
  NameStr                    : String;
  SIJFile                    : TextFile;
  Location                   : TLocation;
  t_MISS                     : TMISSImage;
  cLB, cRT                   : TCoordinate;

Begin
  OpenName := ANSILowerCase(ExtractFileName(Name));
  OpenExt := ANSILowerCase(ExtractFileExt(Name));
  tmpI := pos(OpenExt, OpenName);
  if (tmpI<>0) Then OpenName := copy(OpenName, 1, tmpI-1);

  NameStr := OpenDialog1.FileName;
  if (OpenExt='.sij') Then
  Begin
    assignfile(SIJFile, NameStr);
    reset(SIJFile);

    readln(SIJFile, LB.Northing);
    readln(SIJFile, LB.Easting);
    LB.Datum := International;

    readln(SIJFile, RT.Northing);
    readln(SIJFile, RT.Easting);
    RT.Datum := International;

    readln(SIJFile, Rotate);
    readln(SIJFile, Scale);
    closefile(SIJFile);

    NameStr:=ChangeFileExt(Name,'.bmp');
    if NOT FileExists(NameStr) Then
    Begin
      NameStr := ChangeFileExt(Name,'.pbm');
      if NOT FileExists(NameStr) Then
      Begin
        NameStr := ChangeFileExt(Name,'.gif');
        if NOT FileExists(NameStr) Then
        Begin
          NameStr := ChangeFileExt(Name,'.png');
          if NOT FileExists(NameStr) Then exit;
        End;
      End;
    End;
  End;

  if (OpenExt='.mis') Then
  Begin
    t_MISS := TMISSImage.Create;
    t_MISS.Initialize(NameStr, 0, 0);
    t_MISS.GetMISSGeoInfo(cLB.Longitude, cLB.Latitude, cRT.Longitude, cRT.Latitude,
                          Rotate, Scale);

    cLB.Datum := International;
    cRT.Datum := International;
    Location := TLocation.Create;
    Location.LatLon2Projected(pYKJ, cLB, LB);
    Location.LatLon2Projected(pYKJ, cRT, RT);
    Location.Free;

    t_MISS.free;
  End;

  fake := @map;
  Pict := TPictures.Create;

  tmpI := Pict.LoadImg(NameStr, fake);
  if tmpI <> 0 Then Save1.Enabled := True;

  Pict.free;
end;


procedure TForm1.SavePicture(Name:String);
Var
  Location                   : TLocation;
  cLB, cRT                   : TCoordinate;
  pLB, pRT                   : TProjected;
  fake                       : PImage;
  Pict                       : TPictures;
  SIJFile                    : TextFile;
  tmpStr                     : String;

Begin
  SaveName := ANSILowerCase(ExtractFileName(Name));
  SaveExt := ANSILowerCase(ExtractFileExt(Name));

  fake := @map;
  Pict := TPictures.Create;
  cLB.Latitude := 0; cLB.Longitude := 0;
  cRT.Latitude := 0; cRT.Longitude := 0;

  if (SaveExt='.sij') or (SaveExt='.mis') Then
  Begin
    Form2.lbx.Text := FloatToStr(LB.Easting);
    Form2.lby.Text := FloatToStr(LB.Northing);
    Form2.rtx.Text := FloatToStr(RT.Easting);
    Form2.rty.Text := FloatToStr(RT.Northing);
    Form2.rotate.Text := FLoatToStr(Rotate);
    Form2.scale.Text  := FLoatToStr(Scale);

    if (SaveExt='.mis') Then Form2.GroupBox1.Enabled := True;
    if (SaveExt='.sij') Then Form2.GroupBox1.Enabled := False;

    if (Form2.ShowModal=mrCancel) Then Exit;

    if (SaveExt='.sij') Then
    Begin
      assignfile(SIJFile, Name);
      rewrite(SIJFile);
      str(Form2.lbyp:10:2, tmpStr);   WriteLn(SIJFile, tmpStr);
      str(Form2.lbxp:10:2, tmpStr);   WriteLn(SIJFile, tmpStr);
      str(Form2.rtyp:10:2, tmpStr);   WriteLn(SIJFile, tmpStr);
      str(Form2.rtxp:10:2, tmpStr);   WriteLn(SIJFile, tmpStr);
      str(Form2.rotatep:10:6, tmpStr);WriteLn(SIJFile, tmpStr);
      str(Form2.scalep:10:2, tmpStr); WriteLn(SIJFile, tmpStr);
      str(Map.Width, tmpStr);         WriteLn(SIJFile, tmpStr);
      str(Map.Height, tmpStr);        WriteLn(SIJFile, tmpStr);
      CloseFile(SIJFile);
      Name := ChangeFileExt(Name,'.gif');
    End;

    Location := TLocation.Create;
    pLB.Northing := Form2.lbyp;
    pLB.Easting  := Form2.lbxp;
    pLB.Datum    := International;

    pRT.Northing := Form2.rtyp;
    pRT.Easting  := Form2.rtxp;
    pRT.Datum    := International;

    Location.Projected2LatLon(pYKJ, pLB, cLB);
    Location.Projected2LatLon(pYKJ, pRT, cRT);
    Location.free;
  End;

  Pict.SaveImg(Name, fake, Form2.XGridp, Form2.YGridp, Form2.NColorsp,
               cLB.Longitude, cLB.Latitude, cRT.Longitude, cRT.Latitude, Form2.scalep, Form2.rotatep);

  Pict.free;
end;




end.
