//////////////////////////////////////////////////////////////////////////
//
// The collection of Global variables
//
// Version: 0.1
// Updated: 17.01.2002
// Updates: The code was preserved (17.1.2002 -Florian)
//
//////////////////////////////////////////////////////////////////////////

unit UnitBUS;

interface

uses Windows, defines, classes, SYSUtils, Forms, Graphics, IniFiles, extctrls,
     UnitLocation, MapObj;

type
  TBus = class
  public
    GPSActive                   : Boolean;      // Movements by GPS
    Simulation                  : Boolean;      // Movements by Mouse
    Supervision                 : Boolean;      // Movements by Remote
    Location                    : TLocation;
    appPath                     : String;
    ProjectDir                  : String;
    UserName                    : String;
    DefProjection               : String;
    DefDatum                    : String;
    MapTitle                    : String;


    MainHandle                  : THandle;
    DownloadHandle              : THandle;

    Error                       : Boolean;

    constructor Create;
    destructor Destroy; override;
  end;

var
  Bus: TBus;

implementation

//////////////////////////////////////////////////////////////////////////
// Constructor & Destructor
//////////////////////////////////////////////////////////////////////////
Constructor TBus.Create;
Var
  iniFile                       : TIniFile;
  iniFilePath                   : String;
Begin
  Error := False;
  GPSActive := False;
  appPath := ExtractFilePath(application.ExeName);

  iniFilePath := appPath+'app.ini';
  if FileExists(iniFilePath) Then
  begin
    IniFile       := TIniFile.Create(iniFilePath);
    ProjectDir    := IniFile.ReadString('APP','ProjectDir','.\');
    UserName      := IniFile.ReadString('APP','User','');
    DefProjection := IniFile.ReadString('APP','DefProjection','YKJ');
    DefDatum      := IniFile.ReadString('APP','DefDatum','International');

    IniFile.Free;
  end
  else Error := True;
  Location := TLocation.Create;
End;

Destructor TBus.Destroy;
Var
  iniFile                       : TIniFile;
  iniFilePath                   : String;
Begin
  iniFilePath := appPath+'app.ini';
  if FileExists(iniFilePath) Then
  begin
    IniFile := TIniFile.Create(iniFilePath);
    IniFile.WriteString('APP','ProjectDir',ProjectDir);
    IniFile.WriteString('APP','User',UserName);
    IniFile.Free;
  end;
  appPath       := EmptyStr;
  ProjectDir    := EmptyStr;
  UserName      := EmptyStr;
  DefProjection := EmptyStr;
  DefDatum      := EmptyStr;
  MapTitle      := EmptyStr;
  Location.Free;
End;


end.

